# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free

Name:           jibx
Version:        1.2.3
Release:        2%{?dist}
Epoch:          0
Summary:        JiBX is a framework for binding XML data to Java objects.
License:        Public Domain
Url:            http://jibx.sourceforge.net/
Group:          Text Processing/Markup/XML
Source0:        %{name}_1_2_3.zip
Source1:        http://repo1.maven.org/maven2/org/jibx/jibx-bind/1.2.3/jibx-bind-1.2.3.pom
Source2:        http://repo1.maven.org/maven2/org/jibx/jibx-extras/1.2.3/jibx-extras-1.2.3.pom
Source3:        http://repo1.maven.org/maven2/org/jibx/jibx-run/1.2.3/jibx-run-1.2.3.pom
Source4:        http://repo1.maven.org/maven2/org/jibx/jibx-schema/1.2.3/jibx-schema-1.2.3.pom
Source5:        http://repo1.maven.org/maven2/org/jibx/jibx-tools/1.2.3/jibx-tools-1.2.3.pom

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  ant-junit
BuildRequires:  junit
BuildRequires:  bcel
BuildRequires:  dom4j
BuildRequires:  eclipse-jdt
BuildRequires:  eclipse-platform
BuildRequires:  eclipse-rcp
BuildRequires:  jdom
BuildRequires:  joda-time
BuildRequires:  log4j
BuildRequires:  qdox
BuildRequires:  stax_1_0_api
BuildRequires:  wstx
BuildRequires:  xpp3

%if %{gcj_support}
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

Requires:       java >= 0:1.6.0
Requires:       bcel
Requires:       dom4j
Requires:       eclipse-jdt
Requires:       eclipse-platform
Requires:       eclipse-rcp
Requires:       jdom
Requires:       joda-time
Requires:       log4j
Requires:       qdox
Requires:       stax_1_0_api
Requires:       wstx
Requires:       xpp3
Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5

%if ! %{gcj_support}
BuildArch:      noarch
%endif

BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

%description
JiBX is a framework for binding XML data to Java objects. It lets you
work with data from XML documents using your own class structures.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n %{name}
for j in $(find lib -name "*.jar"); do
    mv $j $j.no
done

%build

# dom4j and jdom are optional. If provided, jibx-extras is built with
# support for those models

ln -s $(build-classpath bcel) lib/
ln -s $(build-classpath dom4j) lib/
ln -s $(build-classpath jdom) lib/
ln -s $(build-classpath joda-time) lib/
ln -s $(build-classpath log4j) lib/
ln -s $(build-classpath qdox) lib/
ln -s $(build-classpath stax_1_0_api) lib/
ln -s $(build-classpath wstx/wstx-asl) lib/
ln -s $(build-classpath xpp3) lib/

ln -s /usr/lib*/eclipse/plugins/org.eclipse.core.contenttype_*.jar lib/org.eclipse.core.contenttype.jar
ln -s /usr/lib*/eclipse/plugins/org.eclipse.core.jobs_*.jar lib/org.eclipse.core.jobs.jar
ln -s /usr/lib*/eclipse/plugins/org.eclipse.core.resources_*.jar lib/org.eclipse.core.resources.jar
ln -s /usr/lib*/eclipse/plugins/org.eclipse.core.runtime_*.jar lib/org.eclipse.core.runtime.jar
ln -s /usr/lib*/eclipse/plugins/org.eclipse.equinox.common_*.jar lib/org.eclipse.equinox.common.jar
ln -s /usr/lib*/eclipse/plugins/org.eclipse.equinox.preferences_*.jar lib/org.eclipse.equinox.preferences.jar
ln -s /usr/lib*/eclipse/dropins/jdt/plugins/org.eclipse.jdt.core_*.jar lib/org.eclipse.jdt.core.jar
ln -s /usr/lib*/eclipse/dropins/jdt/plugins/org.eclipse.jdt.core.manipulation_*.jar lib/org.eclipse.jdt.core.manipulation.jar
ln -s /usr/lib*/eclipse/plugins/org.eclipse.osgi_*.jar lib/org.eclipse.osgi.jar
ln -s /usr/lib*/eclipse/plugins/org.eclipse.jface.text_*.jar lib/org.eclipse.jface.text.jar
ln -s /usr/lib*/eclipse/plugins/org.eclipse.text_*.jar lib/org.eclipse.text.jar


pushd build/
ant

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
for sub_component in bind extras run schema tools; do
install -m 644 lib/jibx-${sub_component}.jar \
     $RPM_BUILD_ROOT%{_javadir}/%{name}/${sub_component}-%{version}.jar
done

%add_to_maven_depmap org.jibx %{name}-bind %{version} JPP/%{name} bind
%add_to_maven_depmap jibx %{name}-bind %{version} JPP/%{name} bind
%add_to_maven_depmap org.jibx %{name}-extras %{version} JPP/%{name} extras
%add_to_maven_depmap jibx %{name}-extras %{version} JPP/%{name} extras
%add_to_maven_depmap org.jibx %{name}-run %{version} JPP/%{name} run
%add_to_maven_depmap jibx %{name}-run %{version} JPP/%{name} run
%add_to_maven_depmap org.jibx %{name}-schema %{version} JPP/%{name} schema
%add_to_maven_depmap jibx %{name}-schema %{version} JPP/%{name} schema
%add_to_maven_depmap org.jibx %{name}-tools %{version} JPP/%{name} tools
%add_to_maven_depmap jibx %{name}-tools %{version} JPP/%{name} tools

# create unprefixed and unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done
)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-bind.pom
install -m 644 %{SOURCE2} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-extras.pom
install -m 644 %{SOURCE3} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-run.pom
install -m 644 %{SOURCE4} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-schema.pom
install -m 644 %{SOURCE5} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-tools.pom

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}
rm -rf docs/api

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Wed Jan 18 2012 Ralph Apel <r.apel at r-apel.de> 0:1.2.3-2
- build with dom4j and jdom

* Sat Jan 14 2012 Ralph Apel <r.apel at r-apel.de> 0:1.2.3-1
- 1.2.3 for JPP-6

* Tue Mar 24 2009 Ralph Apel <r.apel at r-apel.de> 0:1.1.6a-1.jpp5
- Upgrade to 1.1.6a

* Wed May 30 2007 Ralph Apel <r.apel at r-apel.de> 0:1.1.5-1jpp
- Upgrade to 1.1.5
- Make Vendor, Distribution based on macro
- Add gcj_support option
- Install depmap frags, poms

* Wed May 24 2006 Deepak Bhole <dbhole@redhat.com> 0:1.1-0.b3.1jpp
- Initial build
